"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// istanbul ignore file
const os_1 = __importDefault(require("os"));
const path_1 = __importDefault(require("path"));
const core_1 = require("@oclif/core");
const fs_extra_1 = __importDefault(require("fs-extra"));
const base_command_1 = __importDefault(require("../base-command"));
const constant_1 = require("../constant");
const cache_1 = require("../utils/cache");
class CleanCacheCommand extends base_command_1.default {
    static description = '清除缓存';
    async run() {
        const tmpDir = path_1.default.join(os_1.default.tmpdir(), constant_1.TMP_FOLDER_NAME);
        core_1.ux.action.start('正在清除缓存');
        if (fs_extra_1.default.existsSync(tmpDir)) {
            await fs_extra_1.default.remove(tmpDir);
        }
        await (0, cache_1.cleanCaches)();
        core_1.ux.action.stop();
        await this.cleanup();
    }
}
exports.default = CleanCacheCommand;
//# sourceMappingURL=clean-cache.js.map