"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// istanbul ignore file
const core_1 = require("@oclif/core");
const base_command_1 = __importDefault(require("../base-command"));
const linter_1 = require("../utils/linter");
class LintCommand extends base_command_1.default {
    static description = '运行 JS 语法检查';
    async run() {
        let result;
        if (this.flags.fix) {
            result = await (0, linter_1.checkAndFix)(this.projectDir);
        }
        else {
            result = await (0, linter_1.check)(this.projectDir);
        }
        if (!result) {
            console.warn('⚠️  JS 语法检查不通过，请根据提示修改文件（可添加参数 --fix 自动修复部分错误， 参考 https://url.royli.dev/SeB6m）');
            process.exit(1);
        }
        else {
            console.log('✅  JS 语法检查通过');
        }
        await this.cleanup();
    }
}
LintCommand.flags = {
    fix: core_1.Flags.boolean({
        default: false,
        description: '自动修复部分 Lint 错误',
    }),
};
exports.default = LintCommand;
//# sourceMappingURL=lint.js.map