import { ShadowsocksNodeConfig, ShadowsocksSubscribeProviderConfig, SubscriptionUserinfo } from '../types';
import Provider from './Provider';
import { GetNodeListFunction, GetSubscriptionUserInfoFunction } from './types';
export default class ShadowsocksSubscribeProvider extends Provider {
    #private;
    readonly udpRelay?: boolean;
    constructor(name: string, config: ShadowsocksSubscribeProviderConfig);
    get url(): string;
    getSubscriptionUserInfo: GetSubscriptionUserInfoFunction;
    getNodeList: GetNodeListFunction;
}
/**
 * @see https://shadowsocks.org/en/spec/SIP002-URI-Scheme.html
 */
export declare const getShadowsocksSubscription: (url: string, udpRelay?: boolean, requestUserAgent?: string) => Promise<{
    readonly nodeList: Array<ShadowsocksNodeConfig>;
    readonly subscriptionUserinfo?: SubscriptionUserinfo | undefined;
}>;
