import { z } from 'zod';
type SurgioErrorOptions = {
    providerName?: string;
    providerPath?: string;
    nodeIndex?: number;
    cause?: unknown;
};
declare class SurgioError extends Error {
    providerName?: string;
    providerPath?: string;
    nodeIndex?: number;
    cause?: unknown;
    constructor(message: string, options?: SurgioErrorOptions);
    format(): string;
}
export declare const isSurgioError: (val: unknown) => val is SurgioError;
export declare const isZodError: (error: unknown) => error is z.ZodError<any>;
export declare const isError: (val: unknown) => val is Error;
export { SurgioError };
