"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getUserAgent = void 0;
const got_1 = __importDefault(require("got"));
const agentkeepalive_1 = __importStar(require("agentkeepalive"));
const hpagent_1 = require("hpagent");
const constant_1 = require("../constant");
const env_flag_1 = require("./env-flag");
const httpProxy = hasHTTPProxy();
const httpsProxy = hasHTTPSProxy();
const pkg = require('../../package.json');
const agent = !!httpProxy || !!httpsProxy
    ? {
        http: httpProxy
            ? new hpagent_1.HttpProxyAgent({
                keepAlive: true,
                keepAliveMsecs: 1000,
                maxSockets: 256,
                maxFreeSockets: 256,
                scheduling: 'lifo',
                proxy: httpProxy,
            })
            : new agentkeepalive_1.default(),
        https: httpsProxy
            ? new hpagent_1.HttpsProxyAgent({
                keepAlive: true,
                keepAliveMsecs: 1000,
                maxSockets: 256,
                maxFreeSockets: 256,
                scheduling: 'lifo',
                proxy: httpsProxy,
            })
            : new agentkeepalive_1.HttpsAgent(),
    }
    : {
        http: new agentkeepalive_1.default(),
        https: new agentkeepalive_1.HttpsAgent(),
    };
const getUserAgent = (str) => `${str ? str + ' ' : ''}${constant_1.NETWORK_SURGIO_UA}/${pkg.version}`;
exports.getUserAgent = getUserAgent;
const httpClient = got_1.default.extend({
    timeout: (0, env_flag_1.getNetworkTimeout)(),
    retry: (0, env_flag_1.getNetworkRetry)(),
    headers: {
        'user-agent': (0, exports.getUserAgent)(),
    },
    agent,
});
function hasHTTPProxy() {
    return process.env.HTTP_PROXY || process.env.http_proxy;
}
function hasHTTPSProxy() {
    return process.env.HTTPS_PROXY || process.env.https_proxy;
}
exports.default = httpClient;
//# sourceMappingURL=http-client.js.map