import { z } from 'zod';
export declare const ArtifactValidator: z.ZodObject<{
    name: z.ZodString;
    template: z.ZodString;
    templateType: z.ZodDefault<z.ZodUnion<[z.ZodLiteral<"default">, z.ZodLiteral<"json">]>>;
    extendTemplate: z.ZodOptional<z.ZodFunction<z.ZodTuple<[z.ZodUnknown], z.ZodUnknown>, z.ZodUnknown>>;
    provider: z.ZodString;
    categories: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    combineProviders: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
    customParams: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodAny>>;
    customFilters: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodFunction<z.ZodTuple<[], z.ZodUnknown>, z.ZodUnknown>>>;
    destDir: z.ZodOptional<z.ZodString>;
    downloadUrl: z.ZodOptional<z.ZodString>;
    templateString: z.ZodOptional<z.ZodString>;
    subscriptionUserInfoProvider: z.ZodOptional<z.ZodString>;
}, "strip", z.ZodTypeAny, {
    name: string;
    template: string;
    templateType: "default" | "json";
    provider: string;
    extendTemplate?: ((args_0: unknown, ...args_1: unknown[]) => unknown) | undefined;
    categories?: string[] | undefined;
    combineProviders?: string[] | undefined;
    customParams?: Record<string, any> | undefined;
    customFilters?: Record<string, (...args: unknown[]) => unknown> | undefined;
    destDir?: string | undefined;
    downloadUrl?: string | undefined;
    templateString?: string | undefined;
    subscriptionUserInfoProvider?: string | undefined;
}, {
    name: string;
    template: string;
    provider: string;
    templateType?: "default" | "json" | undefined;
    extendTemplate?: ((args_0: unknown, ...args_1: unknown[]) => unknown) | undefined;
    categories?: string[] | undefined;
    combineProviders?: string[] | undefined;
    customParams?: Record<string, any> | undefined;
    customFilters?: Record<string, (...args: unknown[]) => unknown> | undefined;
    destDir?: string | undefined;
    downloadUrl?: string | undefined;
    templateString?: string | undefined;
    subscriptionUserInfoProvider?: string | undefined;
}>;
