"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArtifactValidator = void 0;
const zod_1 = require("zod");
exports.ArtifactValidator = zod_1.z.object({
    name: zod_1.z.string(),
    template: zod_1.z.string(),
    templateType: zod_1.z
        .union([zod_1.z.literal('default'), zod_1.z.literal('json')])
        .default('default'),
    extendTemplate: zod_1.z
        .function()
        .args(zod_1.z.unknown())
        .returns(zod_1.z.unknown())
        .optional(),
    provider: zod_1.z.string(),
    categories: zod_1.z.array(zod_1.z.string()).optional(),
    combineProviders: zod_1.z.array(zod_1.z.string()).optional(),
    customParams: zod_1.z.record(zod_1.z.any()).optional(),
    customFilters: zod_1.z.record(zod_1.z.function()).optional(),
    destDir: zod_1.z.ostring(),
    downloadUrl: zod_1.z.ostring(),
    templateString: zod_1.z.ostring(),
    subscriptionUserInfoProvider: zod_1.z.ostring(),
});
//# sourceMappingURL=artifact.js.map