import { Promisable } from 'type-fest';
import { z } from 'zod';
import { GetNodeListParams } from '../provider';
import { PossibleNodeConfigType } from '../types';
type AfterNodeListResponse = <T extends PossibleNodeConfigType>(nodeList: T[], customParams: GetNodeListParams) => Promisable<T[] | undefined | void>;
export declare const AfterNodeListResponseHookValidator: z.ZodType<AfterNodeListResponse, z.ZodTypeDef, AfterNodeListResponse>;
type OnError = (error: Error) => Promisable<unknown>;
export declare const OnErrorHookValidator: z.ZodType<OnError, z.ZodTypeDef, OnError>;
export {};
