"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpsNodeConfigValidator = exports.HttpNodeConfigValidator = void 0;
const zod_1 = require("zod");
const types_1 = require("../types");
const common_1 = require("./common");
exports.HttpNodeConfigValidator = common_1.SimpleNodeConfigValidator.extend({
    type: zod_1.z.literal(types_1.NodeTypeEnum.HTTP),
    hostname: zod_1.z.string(),
    port: common_1.PortValidator,
    username: zod_1.z.string(),
    password: zod_1.z.string(),
    path: zod_1.z.string().optional(),
    headers: zod_1.z.record(zod_1.z.string()).optional(),
});
exports.HttpsNodeConfigValidator = common_1.TlsNodeConfigValidator.extend({
    type: zod_1.z.literal(types_1.NodeTypeEnum.HTTPS),
    username: zod_1.z.string(),
    password: zod_1.z.string(),
    path: zod_1.z.string().optional(),
    headers: zod_1.z.record(zod_1.z.string()).optional(),
});
//# sourceMappingURL=http.js.map