import { z } from 'zod';
import { SupportProviderEnum } from '../types';
export declare const ProviderValidator: z.ZodObject<{
    type: z.ZodNativeEnum<typeof SupportProviderEnum>;
    addFlag: z.ZodOptional<z.ZodBoolean>;
    removeExistingFlag: z.ZodOptional<z.ZodBoolean>;
    mptcp: z.ZodOptional<z.ZodBoolean>;
    tfo: z.ZodOptional<z.ZodBoolean>;
    ecn: z.ZodOptional<z.ZodBoolean>;
    blockQuic: z.ZodOptional<z.ZodUnion<[z.ZodLiteral<"auto">, z.ZodLiteral<"on">, z.ZodLiteral<"off">]>>;
    underlyingProxy: z.ZodOptional<z.ZodString>;
    startPort: z.ZodOptional<z.ZodNumber>;
    relayUrl: z.ZodOptional<z.ZodString>;
    requestUserAgent: z.ZodOptional<z.ZodString>;
    renameNode: z.ZodOptional<z.ZodFunction<z.ZodTuple<[z.ZodString], z.ZodUnknown>, z.ZodUnion<[z.ZodString, z.ZodUndefined, z.ZodVoid]>>>;
    customFilters: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodType<(nodeConfig: import("../types").PossibleNodeConfigType) => boolean, z.ZodTypeDef, (nodeConfig: import("../types").PossibleNodeConfigType) => boolean>, z.ZodType<{
        readonly filter: <T extends import("../types").PossibleNodeConfigType>(nodeList: readonly T[]) => readonly T[];
        readonly supportSort: true;
    }, z.ZodTypeDef, {
        readonly filter: <T extends import("../types").PossibleNodeConfigType>(nodeList: readonly T[]) => readonly T[];
        readonly supportSort: true;
    }>]>>>;
    nodeFilter: z.ZodOptional<z.ZodUnion<[z.ZodType<(nodeConfig: import("../types").PossibleNodeConfigType) => boolean, z.ZodTypeDef, (nodeConfig: import("../types").PossibleNodeConfigType) => boolean>, z.ZodType<{
        readonly filter: <T extends import("../types").PossibleNodeConfigType>(nodeList: readonly T[]) => readonly T[];
        readonly supportSort: true;
    }, z.ZodTypeDef, {
        readonly filter: <T extends import("../types").PossibleNodeConfigType>(nodeList: readonly T[]) => readonly T[];
        readonly supportSort: true;
    }>]>>;
    netflixFilter: z.ZodOptional<z.ZodUnion<[z.ZodType<(nodeConfig: import("../types").PossibleNodeConfigType) => boolean, z.ZodTypeDef, (nodeConfig: import("../types").PossibleNodeConfigType) => boolean>, z.ZodType<{
        readonly filter: <T extends import("../types").PossibleNodeConfigType>(nodeList: readonly T[]) => readonly T[];
        readonly supportSort: true;
    }, z.ZodTypeDef, {
        readonly filter: <T extends import("../types").PossibleNodeConfigType>(nodeList: readonly T[]) => readonly T[];
        readonly supportSort: true;
    }>]>>;
    youtubePremiumFilter: z.ZodOptional<z.ZodUnion<[z.ZodType<(nodeConfig: import("../types").PossibleNodeConfigType) => boolean, z.ZodTypeDef, (nodeConfig: import("../types").PossibleNodeConfigType) => boolean>, z.ZodType<{
        readonly filter: <T extends import("../types").PossibleNodeConfigType>(nodeList: readonly T[]) => readonly T[];
        readonly supportSort: true;
    }, z.ZodTypeDef, {
        readonly filter: <T extends import("../types").PossibleNodeConfigType>(nodeList: readonly T[]) => readonly T[];
        readonly supportSort: true;
    }>]>>;
    hooks: z.ZodOptional<z.ZodObject<{
        afterNodeListResponse: z.ZodOptional<z.ZodType<(<T_1 extends import("../types").PossibleNodeConfigType>(nodeList: T_1[], customParams: import("../provider").GetNodeListParams) => import("type-fest").Promisable<void | T_1[] | undefined>), z.ZodTypeDef, <T_1 extends import("../types").PossibleNodeConfigType>(nodeList: T_1[], customParams: import("../provider").GetNodeListParams) => import("type-fest").Promisable<void | T_1[] | undefined>>>;
        onError: z.ZodOptional<z.ZodType<(error: Error) => unknown, z.ZodTypeDef, (error: Error) => unknown>>;
    }, "strip", z.ZodTypeAny, {
        afterNodeListResponse?: (<T_1 extends import("../types").PossibleNodeConfigType>(nodeList: T_1[], customParams: import("../provider").GetNodeListParams) => import("type-fest").Promisable<void | T_1[] | undefined>) | undefined;
        onError?: ((error: Error) => unknown) | undefined;
    }, {
        afterNodeListResponse?: (<T_1 extends import("../types").PossibleNodeConfigType>(nodeList: T_1[], customParams: import("../provider").GetNodeListParams) => import("type-fest").Promisable<void | T_1[] | undefined>) | undefined;
        onError?: ((error: Error) => unknown) | undefined;
    }>>;
}, "strip", z.ZodTypeAny, {
    type: SupportProviderEnum;
    addFlag?: boolean | undefined;
    removeExistingFlag?: boolean | undefined;
    mptcp?: boolean | undefined;
    tfo?: boolean | undefined;
    ecn?: boolean | undefined;
    blockQuic?: "auto" | "on" | "off" | undefined;
    underlyingProxy?: string | undefined;
    startPort?: number | undefined;
    relayUrl?: string | undefined;
    requestUserAgent?: string | undefined;
    renameNode?: ((args_0: string, ...args_1: unknown[]) => string | void | undefined) | undefined;
    customFilters?: Record<string, ((nodeConfig: import("../types").PossibleNodeConfigType) => boolean) | {
        readonly filter: <T extends import("../types").PossibleNodeConfigType>(nodeList: readonly T[]) => readonly T[];
        readonly supportSort: true;
    }> | undefined;
    nodeFilter?: ((nodeConfig: import("../types").PossibleNodeConfigType) => boolean) | {
        readonly filter: <T extends import("../types").PossibleNodeConfigType>(nodeList: readonly T[]) => readonly T[];
        readonly supportSort: true;
    } | undefined;
    netflixFilter?: ((nodeConfig: import("../types").PossibleNodeConfigType) => boolean) | {
        readonly filter: <T extends import("../types").PossibleNodeConfigType>(nodeList: readonly T[]) => readonly T[];
        readonly supportSort: true;
    } | undefined;
    youtubePremiumFilter?: ((nodeConfig: import("../types").PossibleNodeConfigType) => boolean) | {
        readonly filter: <T extends import("../types").PossibleNodeConfigType>(nodeList: readonly T[]) => readonly T[];
        readonly supportSort: true;
    } | undefined;
    hooks?: {
        afterNodeListResponse?: (<T_1 extends import("../types").PossibleNodeConfigType>(nodeList: T_1[], customParams: import("../provider").GetNodeListParams) => import("type-fest").Promisable<void | T_1[] | undefined>) | undefined;
        onError?: ((error: Error) => unknown) | undefined;
    } | undefined;
}, {
    type: SupportProviderEnum;
    addFlag?: boolean | undefined;
    removeExistingFlag?: boolean | undefined;
    mptcp?: boolean | undefined;
    tfo?: boolean | undefined;
    ecn?: boolean | undefined;
    blockQuic?: "auto" | "on" | "off" | undefined;
    underlyingProxy?: string | undefined;
    startPort?: number | undefined;
    relayUrl?: string | undefined;
    requestUserAgent?: string | undefined;
    renameNode?: ((args_0: string, ...args_1: unknown[]) => string | void | undefined) | undefined;
    customFilters?: Record<string, ((nodeConfig: import("../types").PossibleNodeConfigType) => boolean) | {
        readonly filter: <T extends import("../types").PossibleNodeConfigType>(nodeList: readonly T[]) => readonly T[];
        readonly supportSort: true;
    }> | undefined;
    nodeFilter?: ((nodeConfig: import("../types").PossibleNodeConfigType) => boolean) | {
        readonly filter: <T extends import("../types").PossibleNodeConfigType>(nodeList: readonly T[]) => readonly T[];
        readonly supportSort: true;
    } | undefined;
    netflixFilter?: ((nodeConfig: import("../types").PossibleNodeConfigType) => boolean) | {
        readonly filter: <T extends import("../types").PossibleNodeConfigType>(nodeList: readonly T[]) => readonly T[];
        readonly supportSort: true;
    } | undefined;
    youtubePremiumFilter?: ((nodeConfig: import("../types").PossibleNodeConfigType) => boolean) | {
        readonly filter: <T extends import("../types").PossibleNodeConfigType>(nodeList: readonly T[]) => readonly T[];
        readonly supportSort: true;
    } | undefined;
    hooks?: {
        afterNodeListResponse?: (<T_1 extends import("../types").PossibleNodeConfigType>(nodeList: T_1[], customParams: import("../provider").GetNodeListParams) => import("type-fest").Promisable<void | T_1[] | undefined>) | undefined;
        onError?: ((error: Error) => unknown) | undefined;
    } | undefined;
}>;
