"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShadowsocksNodeConfigValidator = void 0;
const zod_1 = require("zod");
const types_1 = require("../types");
const common_1 = require("./common");
exports.ShadowsocksNodeConfigValidator = common_1.SimpleNodeConfigValidator.extend({
    type: zod_1.z.literal(types_1.NodeTypeEnum.Shadowsocks),
    hostname: zod_1.z.string(),
    port: common_1.PortValidator,
    method: zod_1.z.string(),
    password: zod_1.z.string(),
    udpRelay: zod_1.z.oboolean(),
    obfs: zod_1.z
        .union([
        zod_1.z.literal('tls'),
        zod_1.z.literal('http'),
        zod_1.z.literal('ws'),
        zod_1.z.literal('wss'),
        zod_1.z.literal('quic'),
    ])
        .optional(),
    obfsHost: zod_1.z.ostring(),
    obfsUri: zod_1.z.ostring(),
    skipCertVerify: zod_1.z.oboolean(),
    wsHeaders: zod_1.z.record(zod_1.z.string()).optional(),
    tls13: zod_1.z.oboolean(),
    mux: zod_1.z.oboolean(),
    multiplex: common_1.MultiplexValidator.optional(),
});
//# sourceMappingURL=shadowsocks.js.map