"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SnellNodeConfigValidator = void 0;
const zod_1 = require("zod");
const types_1 = require("../types");
const common_1 = require("./common");
exports.SnellNodeConfigValidator = common_1.SimpleNodeConfigValidator.extend({
    type: zod_1.z.literal(types_1.NodeTypeEnum.Snell),
    hostname: zod_1.z.string(),
    port: common_1.PortValidator,
    psk: zod_1.z.string(),
    obfs: zod_1.z.union([zod_1.z.literal('http'), zod_1.z.literal('tls')]).optional(),
    obfsHost: zod_1.z.ostring(),
    reuse: zod_1.z.oboolean(),
    version: common_1.IntegersVersionValidator.optional(),
});
//# sourceMappingURL=snell.js.map