"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TrojanNodeConfigValidator = void 0;
const zod_1 = require("zod");
const types_1 = require("../types");
const common_1 = require("./common");
exports.TrojanNodeConfigValidator = common_1.TlsNodeConfigValidator.extend({
    type: zod_1.z.literal(types_1.NodeTypeEnum.Trojan),
    password: zod_1.z.string(),
    udpRelay: zod_1.z.oboolean(),
    network: zod_1.z.union([zod_1.z.literal('tcp'), zod_1.z.literal('ws')]).optional(),
    wsPath: zod_1.z.ostring(),
    wsHeaders: zod_1.z.record(zod_1.z.string()).optional(),
    multiplex: common_1.MultiplexValidator.optional(),
});
//# sourceMappingURL=trojan.js.map