"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TuicNodeConfigValidator = exports.TuicNodeV4ConfigValidator = exports.TuicNodeV5ConfigValidator = void 0;
const zod_1 = require("zod");
const types_1 = require("../types");
const common_1 = require("./common");
exports.TuicNodeV5ConfigValidator = common_1.TlsNodeConfigValidator.extend({
    type: zod_1.z.literal(types_1.NodeTypeEnum.Tuic),
    password: zod_1.z.string(),
    uuid: zod_1.z.string(),
    version: common_1.IntegersVersionValidator,
});
exports.TuicNodeV4ConfigValidator = common_1.TlsNodeConfigValidator.extend({
    type: zod_1.z.literal(types_1.NodeTypeEnum.Tuic),
    token: zod_1.z.string(),
});
exports.TuicNodeConfigValidator = zod_1.z.union([
    exports.TuicNodeV4ConfigValidator,
    exports.TuicNodeV5ConfigValidator,
]);
//# sourceMappingURL=tuic.js.map