"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VlessNodeConfigValidator = exports.VlessRealityOptsValidator = void 0;
const zod_1 = require("zod");
const types_1 = require("../types");
const common_1 = require("./common");
const vmess_1 = require("./vmess");
exports.VlessRealityOptsValidator = zod_1.z.object({
    publicKey: zod_1.z.string(),
    shortId: zod_1.z.ostring(),
    spiderX: zod_1.z.ostring(),
});
exports.VlessNodeConfigValidator = common_1.TlsNodeConfigValidator.extend({
    type: zod_1.z.literal(types_1.NodeTypeEnum.Vless),
    hostname: zod_1.z.string(),
    port: common_1.PortValidator,
    method: zod_1.z.literal('none'),
    uuid: zod_1.z.string().uuid(),
    network: vmess_1.VmessNetworkValidator.default('tcp'),
    udpRelay: zod_1.z.oboolean(),
    flow: zod_1.z.ostring(),
    wsOpts: vmess_1.VmessWSOptsValidator.optional(),
    h2Opts: vmess_1.VmessH2OptsValidator.optional(),
    httpOpts: vmess_1.VmessHttpOptsValidator.optional(),
    grpcOpts: vmess_1.VmessGRPCOptsValidator.optional(),
    quicOpts: vmess_1.VmessQuicOptsValidator.optional(),
    httpUpgradeOpts: vmess_1.VmessHttpUpgradeOptsValidator.optional(),
    realityOpts: exports.VlessRealityOptsValidator.optional(),
    multiplex: common_1.MultiplexValidator.optional(),
});
//# sourceMappingURL=vless.js.map